## galera-26.4.14.tar.gz.1c167945d95d63aec27cee15cad1affc

=== SConstruct ===
###################################################################
#
# Copyright (C) 2010-2020 Codership Oy <info@codership.com>
#
# SCons build script to build galera libraries
#
# How to control the build with environment variables:
# Set CC       to specify C compiler
# Set CXX      to specify C++ compiler
# Set CPPFLAGS to add non-standard include paths and preprocessor macros
# Set CCFLAGS  to *override* optimization and architecture-specific options
# Set CFLAGS   to supply C compiler options
# Set CXXFLAGS to supply C++ compiler options
# Set LDFLAGS  to *override* linking flags
# Set LIBPATH  to add non-standard linker paths
# Set RPATH    to add rpaths
#
# Some useful CPPFLAGS:
# GCS_SM_DEBUG          - enable dumping of send monitor state and history
# GU_DEBUG_MUTEX        - enable mutex debug instrumentation
# GU_DBUG_ON            - enable sync point macros
#
# Script structure:
# - Help message
# - Default parameters
# - Read commandline options
# - Set up and configure default build environment
# - Set up and configure check unit test build environment
# - Run root SConscript with variant_dir
#
####################################################################

import os
import platform
import string
import subprocess

# Execute a command and read the first line of its stdout.
# For example read_first_line(["ls", "-l", "/usr"])
def read_first_line(cmd):
    p = subprocess.Popen(cmd, stdout=subprocess.PIPE)
    stdout = p.communicate()[0]
    line = stdout.splitlines()[0]
    return line

sysname = os.uname()[0].lower()
machine = platform.machine()
bits = ARGUMENTS.get('bits', platform.architecture()[0])
print('Host: ' + sysname + ' ' + machine + ' ' + bits)

x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386', 'i86pc' ])

if bits == '32bit':
    bits = 32
elif bits == '64bit':
    bits = 64

#
# Print Help
#

Help('''
Build targets:  build tests check install all
Default target: all

Commandline Options:
    debug=n             debug build with optimization level n
    asan=[0|1]          disable or enable ASAN instrumentation
    build_dir=dir       build directory, default: '.'
    boost=[0|1]         disable or enable boost libraries
    system_asio=[0|1]   use system asio library, if available
    asio_path=path      path to asio headers
    boost_pool=[0|1]    use or not use boost pool allocator
    revno=XXXX          source code revision number
    bpostatic=path      a path to static libboost_program_options.a
    ssl=[0|1]           build without/with SSL enabled
    static_ssl=path     a path to static SSL libraries
    extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
    bits=[32bit|64bit]
    gcov=[True|False]   compile Galera for code coverage reporting
    install=path        install files under path
    version_script=[0|1] Use version script (default 1)
    crc32c_no_hardware=[0|1] disable building hardware support for CRC32C
''')
# bpostatic option added on Percona request

#
# Default params
#

build_target = 'all'

# Optimization level
opt_flags    = ' -g -O3 -DNDEBUG'

# Architecture (defaults to build host type)
compile_arch = ''
link_arch    = ''

# Build directory
build_dir    = ''

# Version script file
galera_script = File('#/galera/src/galera-sym.map').abspath

#
# Read commandline options
#

build_dir = ARGUMENTS.get('build_dir', '')

# Debug/dbug flags
debug = ARGUMENTS.get('debug', -1)
dbug  = ARGUMENTS.get('dbug', False)
asan = ARGUMENTS.get('asan', 0)
gcov = ARGUMENTS.get('gcov', False)

debug_lvl = int(debug)
if debug_lvl >= 0 and debug_lvl < 3:
    opt_flags = ' -g -O%d -fno-inline' % debug_lvl
    dbug = True
elif debug_lvl == 3:
    opt_flags = ' -g -O3'

if dbug:
    opt_flags = opt_flags + ' -DGU_DBUG_ON'

if gcov:
    opt_flags = opt_flags + ' --coverage -g'

if sysname == 'sunos':
    compile_arch = ' -mtune=native'
elif x86:
    if bits == 32:
        if machine == 'x86_64':
            compile_arch = ' -mx32'
        else:
            compile_arch = ' -m32 -march=i686'
            if sysname == 'linux':
                link_arch = ' -Wl,-melf_i386'
    else:
        if machine == 'ppc64':
          compile_arch = ' -mtune=native'
          link_arch = ' -Wl,-melf64ppc'
        elif machine == 'ppc64le':
          compile_arch = ' -mtune=native'
          link_arch = ' -Wl,-melf64lppc'
        else:
          compile_arch = ' -m64'
          if sysname == 'linux':
            link_arch = ' -Wl,-melf_x86_64'
        link_arch = compile_arch + link_arch
elif machine == 's390x':
    compile_arch = ' -mzarch'
    if bits == 32:
        compile_arch += ' -m32'

boost      = int(ARGUMENTS.get('boost', 1))
boost_pool = int(ARGUMENTS.get('boost_pool', 0))
system_asio= int(ARGUMENTS.get('system_asio', 1))
asio_path  = ARGUMENTS.get('asio_path')
tests      = int(ARGUMENTS.get('tests', 1))
# Run only tests which are known to be deterministic
deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
# Run all tests
all_tests = int(ARGUMENTS.get('all_tests', 0))
strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
have_ssl = int(ARGUMENTS.get('ssl', 1))
static_ssl = ARGUMENTS.get('static_ssl', None)
install = ARGUMENTS.get('install', None)
version_script = int(ARGUMENTS.get('version_script', 1))

GALERA_VER = ARGUMENTS.get('version', '4.14')
GALERA_REV = ARGUMENTS.get('revno', 'XXXX')

# Attempt to read from file if not given
if GALERA_REV == "XXXX" and os.path.isfile("GALERA_REVISION"):
    with open("GALERA_REVISION", "r") as f:
        GALERA_REV = f.readline().rstrip("\n")

# export to any module that might have use of those
Export('GALERA_VER', 'GALERA_REV')
print('Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV)

LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '')
LIBBOOST_SYSTEM_A = LIBBOOST_PROGRAM_OPTIONS_A.replace('boost_program_options', 'boost_system')

#
# Set up and export default build environment
#

env = Environment(ENV = {'PATH' : os.environ['PATH'], 'HOME' : os.environ['HOME']})

# Set up environment for ccache and distcc
#env['ENV']['HOME']          = os.environ['HOME']
#env['ENV']['DISTCC_HOSTS']  = os.environ['DISTCC_HOSTS']
#env['ENV']['CCACHE_PREFIX'] = os.environ['CCACHE_PREFIX']
if 'CCACHE_DIR' in os.environ:
    env['ENV']['CCACHE_DIR'] = os.environ['CCACHE_DIR']
if 'CCACHE_CPP2' in os.environ:
    env['ENV']['CCACHE_CPP2'] = os.environ['CCACHE_CPP2']

# Set CC and CXX compilers
cc = os.getenv('CC', 'default')
if cc != 'default':
    env.Replace(CC = cc)
cxx = os.getenv('CXX', 'default')
if cxx != 'default':
    env.Replace(CXX = cxx)
link = os.getenv('LINK', 'default')
if link != 'default':
    env.Replace(LINK = link)

# Get compiler name/version, CXX may be set to "c++" which may be clang or gcc
cc_version = str(read_first_line(env['CC'].split() + ['--version']))
cxx_version = str(read_first_line(env['CXX'].split() + ['--version']))

print('Using C compiler executable: ' + env['CC'])
print('C compiler version is: ' + cc_version)
print('Using C++ compiler executable: ' + env['CXX'])
print('C++ compiler version is: ' + cxx_version)

# Initialize CPPFLAGS and LIBPATH from environment to get user preferences
env.Replace(CPPFLAGS  = os.getenv('CPPFLAGS', ''))
env.Replace(CCFLAGS   = os.getenv('CCFLAGS',  opt_flags + compile_arch))
env.Replace(CFLAGS    = os.getenv('CFLAGS',   ''))
env.Replace(CXXFLAGS  = os.getenv('CXXFLAGS', ''))
env.Replace(LINKFLAGS = os.getenv('LDFLAGS',  link_arch))
env.Replace(LIBPATH   = [os.getenv('LIBPATH', '')])
env.Replace(RPATH     = [os.getenv('RPATH',   '')])

# Set -pthread flag explicitly to make sure that pthreads are
# enabled on all platforms.
env.Append(CCFLAGS = ' -pthread')

# FreeBSD ports are usually installed under /usr/local
if sysname == 'freebsd' or sysname == 'sunos':
    env.Append(LIBPATH = ['/usr/local/lib'])
    env.Append(CPPPATH = ['/usr/local/include'])
if sysname == 'sunos':
   env.Replace(SHLINKFLAGS = '-shared ')

# Add paths is extra_sysroot argument was specified
extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
if sysname == 'darwin' and extra_sysroot == '':
    # common developer environments and paths
    if os.system('which -s port') == 0 and os.path.isfile('/opt/local/bin/port'):
        extra_sysroot = '/opt/local'
    elif os.system('which -s brew') == 0 and os.path.isfile('/usr/local/bin/brew'):
        extra_sysroot = '/usr/local'
    elif os.system('which -s fink') == 0 and os.path.isfile('/sw/bin/fink'):
        extra_sysroot = '/sw'
if extra_sysroot != '':
    env.Append(LIBPATH = [extra_sysroot + '/lib'])
    env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')

# print env.Dump()

# Preprocessor flags
if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
    env.Append(CPPFLAGS = ' -D_XOPEN_SOURCE=600')
if sysname == 'sunos':
    env.Append(CPPFLAGS = ' -D__EXTENSIONS__')
env.Append(CPPFLAGS = ' -DHAVE_COMMON_H')

# Common C/CXX flags
# These should be kept minimal as they are appended after C/CXX specific flags
env.Append(CCFLAGS = ' -fPIC -Wall -Wextra -Wno-unused-parameter')

# C-specific flags
env.Prepend(CFLAGS = '-std=c99 -fno-strict-aliasing -pipe ')

# CXX-specific flags
# Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
#       adding those after checks
env.Prepend(CXXFLAGS = '-Wno-long-long -Wno-deprecated ')
if sysname != 'sunos':
    env.Prepend(CXXFLAGS = '-pipe ')


# Linker flags
# TODO: enable ' -Wl,--warn-common -Wl,--fatal-warnings' after warnings from
# static linking have beed addressed
#
#env.Prepend(LINKFLAGS = '-Wl,--warn-common -Wl,--fatal-warnings ')
if int(asan):
    env.Append(CCFLAGS = ' -fsanitize=address')
    env.Append(CPPFLAGS = ' -DGALERA_WITH_ASAN')
    env.Append(LINKFLAGS = ' -fsanitize=address')

if gcov:
    env.Append(LINKFLAGS = ' --coverage -g')

#
# Check required headers and libraries (autoconf functionality)
#

#
# Custom tests:
#

def CheckCpp0x(context):
    test_source = """
int main() { return 0; }
"""
    context.Message('Checking if compiler accepts -std=c++0x ... ')
    cxxflags_orig = context.env['CXXFLAGS']
    context.env.Prepend(CXXFLAGS = '-std=c++0x ')
    result = context.TryLink(test_source, '.cpp')
    context.env.Replace(CXXFLAGS = cxxflags_orig)
    context.Result(result)
    return result

def CheckCpp11(context):
    test_source = """
int main() { return 0; }
"""
    context.Message('Checking if compiler accepts -std=c++11 ... ')
    cxxflags_orig = context.env['CXXFLAGS']
    context.env.Prepend(CXXFLAGS = '-std=c++11 ')
    result = context.TryLink(test_source, '.cpp')
    context.env.Replace(CXXFLAGS = cxxflags_orig)
    context.Result(result)
    return result

def CheckSystemASIOVersion(context):
    system_asio_test_source_file = """
#include <asio.hpp>

#define XSTR(x) STR(x)
#define STR(x) #x
#pragma message "Asio version:" XSTR(ASIO_VERSION)
#if ASIO_VERSION < 101008
#error Included asio version is too old
#elif ASIO_VERSION >= 101100
#error Included asio version is too new
#endif

int main()
{
    return 0;
}

"""
    context.Message('Checking ASIO version (>= 1.10.8 and < 1.11.0) ... ')
    result = context.TryLink(system_asio_test_source_file, '.cpp')
    context.Result(result)
    return result

def CheckTr1Array(context):
    test_source = """
#include <tr1/array>
int main() { std::tr1::array<int, 5> a; return 0; }
"""
    context.Message('Checking for std::tr1::array ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckStdSharedPtr(context):
    test_source = """
#include <memory>
int main() { int n; std::shared_ptr<int> p(&n); return 0; }
"""
    context.Message('Checking for std::shared_ptr ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckTr1UnorderedMap(context):
    test_source = """
#include <tr1/unordered_map>
int main() { std::tr1::unordered_map<int, int> m; return 0; }
"""

=== galera/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

add_subdirectory(src)
add_subdirectory(tests)

=== galera/src/CMakeLists.txt ===
#
# Copyright (C) 2020-2021 Codership Oy <info@codership.com>
#

add_library(galera STATIC
  mapped_buffer.cpp
  write_set.cpp
  data_set.cpp
  key_set.cpp
  write_set_ng.cpp
  trx_handle.cpp
  key_entry_os.cpp
  wsdb.cpp
  certification.cpp
  galera_service_thd.cpp
  wsrep_params.cpp
  replicator_smm_params.cpp
  gcs_action_source.cpp
  galera_info.cpp
  galera_view.cpp
  replicator.cpp
  ist.cpp
  ist_proto.cpp
  gcs_dummy.cpp
  saved_state.cpp
  replicator_smm.cpp
  replicator_str.cpp
  replicator_smm_stats.cpp
  )

target_include_directories(galera
  PRIVATE
  ${PROJECT_SOURCE_DIR}/wsrep/src
  ${PROJECT_SOURCE_DIR}/wsrep/ps
  )

# TODO: Fix.
target_compile_options(galera
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

if (GALERA_STATIC)
  target_link_libraries(galera gcs -static-libgcc)
else()
  target_link_libraries(galera gcs)
endif()

add_library(galera_smm_static STATIC
  wsrep_provider.cpp
  )

target_compile_definitions(galera_smm_static
  PRIVATE
  -DGALERA_VER="${GALERA_VERSION}"
  -DGALERA_REV="${GALERA_GIT_REVISION}"
  -DGALERA_MULTIMASTER
  )

target_include_directories(galera_smm_static
  PRIVATE
  ${PROJECT_SOURCE_DIR}/wsrep/src
  ${PROJECT_SOURCE_DIR}/wsrep/ps
  )

# TODO: Fix.
target_compile_options(galera_smm_static
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

target_link_libraries(galera_smm_static galera)

add_library(galera_smm  MODULE
  wsrep_provider.cpp
  )

set_target_properties(galera_smm PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}
  )

target_include_directories(galera_smm
  PRIVATE
  ${PROJECT_SOURCE_DIR}/wsrep/src
  ${CMAKE_SOURCE_DIR}/wsrep/ps
  )

target_compile_definitions(galera_smm
  PRIVATE
  -DGALERA_VER="${GALERA_VERSION}"
  -DGALERA_REV="${GALERA_GIT_REVISION}"
  -DGALERA_MULTIMASTER
  )

# TODO: Fix.
target_compile_options(galera_smm
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

if (GALERA_VERSION_SCRIPT)
  # Limit symbols visible from Galera DSO.
  # Doing this allows to:
  # - make the ABI more clean and concise
  # - hide symbols from commonly used libraries (boost, asio, etc.), which
  #   binds calls inside the DSO to its own versions of these libraries
  # See: https://akkadia.org/drepper/dsohowto.pdf (section 2.2.5)
  set(GALERA_LINK_OPTIONS
    -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/galera-sym.map)
endif()

target_link_libraries(galera_smm galera ${GALERA_LINK_OPTIONS})

install(TARGETS galera_smm DESTINATION lib)

# The following checks are guaranteed to work only
# Linux platform, we skip them on others.
if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  return()
endif()

#
# Post build checks:
# - Check that symbol visibility matches GALERA_VERSION_SCRIPT.
# - Check that SSL linkage matches GALERA_HAVE_SSL and GALERA_STATIC.
#
if (GALERA_VERSION_SCRIPT)
  add_custom_command(TARGET galera_smm POST_BUILD
    COMMAND
    sh -c "! ${CMAKE_OBJDUMP} -T libgalera_smm.so | grep asio 1> /dev/null"
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
    COMMENT "Checking library symbol visibility (hidden)"
    VERBATIM)
else()
  set(GALERA_LINK_OPTIONS "")
  add_custom_command(TARGET galera_smm POST_BUILD
    COMMAND
    sh -c "${CMAKE_OBJDUMP} -T libgalera_smm.so | grep asio 1> /dev/null"
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
    COMMENT "Checking library symbol visibility (not hidden)"
    VERBATIM)
endif()

if (NOT GALERA_WITH_SSL)
  message(STATUS "Building Galera without SSL")
  add_custom_command(TARGET galera_smm POST_BUILD
    COMMAND
    sh -c "! (${CMAKE_OBJDUMP} -x libgalera_smm.so | grep NEEDED.*crypto 1> /dev/null) && ! (${CMAKE_OBJDUMP} -x libgalera_smm.so | grep NEEDED.*ssl 1> /dev/null)"
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
    COMMENT "Verifying that library is not linked with SSL"
    VERBATIM)
else()
  if (GALERA_STATIC)
    message(STATUS "Building Galera with static SSL")
    add_custom_command(TARGET galera_smm POST_BUILD
      COMMAND
      sh -c "(${CMAKE_OBJDUMP} -t libgalera_smm.so | grep OPENSSL 1> /dev/null) && (${CMAKE_OBJDUMP} -t libgalera_smm.so | grep CRYPTO 1> /dev/null)"
      WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
      COMMENT "Verifying that library has OpenSSL linked statically"
      VERBATIM)
  else()
    message(STATUS "Building Galera with SSL")
    add_custom_command(TARGET galera_smm POST_BUILD
      COMMAND
      sh -c "(${CMAKE_OBJDUMP} -x libgalera_smm.so | grep NEEDED.*crypto 1> /dev/null) && (${CMAKE_OBJDUMP} -x libgalera_smm.so | grep NEEDED.*ssl 1> /dev/null)"
      COMMENT "Verifying that library is linked with SSL"
      WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
      VERBATIM)
  endif()
endif()

=== gcache/src/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

#
# GCache library
#

add_library(gcache STATIC
  GCache_seqno.cpp
  gcache_params.cpp
  gcache_page.cpp
  gcache_page_store.cpp
  gcache_rb_store.cpp
  gcache_mem_store.cpp
  gcache_test_encryption.cpp
  GCache_memops.cpp
  GCache.cpp
  )

# TODO: Fix.
target_compile_options(gcache
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

target_link_libraries(gcache galerautilsxx)

#
# Gcache test
#

add_executable(gcache_test test.cpp)

target_link_libraries(gcache_test gcache pthread rt)

target_compile_options(gcache_test
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter)

=== gcs/src/unit_tests/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

add_executable(gcs_tests
  gcs_tests.cpp
  gcs_test_utils.cpp
  gcs_act_cchange_test.cpp
  ../gcs_act_cchange.cpp
  gcs_fifo_test.cpp
  ../gcs_fifo_lite.cpp
  gcs_sm_test.cpp
  ../gcs_sm.cpp
  gcs_comp_test.cpp
  ../gcs_comp_msg.cpp
  gcs_state_msg_test.cpp
  ../gcs_state_msg.cpp
  gcs_backend_test.cpp
  ../gcs_backend.cpp
  gcs_proto_test.cpp
  ../gcs_act_proto.cpp
  gcs_defrag_test.cpp
  ../gcs_defrag.cpp
  gcs_node_test.cpp
  ../gcs_node.cpp
  gcs_group_test.cpp
  gcs_memb_test.cpp
  ../gcs_group.cpp
  gcs_core_test.cpp
  ../gcs_code_msg.cpp
  ../gcs_core.cpp
  ../gcs_dummy.cpp
  ../gcs_msg_type.cpp
  ../gcs.cpp
  ../gcs_params.cpp
  gcs_fc_test.cpp
  ../gcs_fc.cpp
  )

target_compile_definitions(gcs_tests
  PRIVATE
  -DGALERA_LOG_H_ENABLE_CXX
  -DGCS_CORE_TESTING
  -DGCS_DUMMY_TESTING
  )
if (GALERA_NONDETERMINISTIC_TESTS)
  target_compile_definitions(gcs_tests
    PRIVATE
    -DGCS_ALLOW_GH74
    )
endif()

# TODO: Fix.
target_compile_options(gcs_tests
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  -Wno-vla
  )

target_link_libraries(gcs_tests
  gcache
  ${GALERA_UNIT_TEST_LIBS}
  ${Boost_FILESYSTEM_LIBRARIES}
  ${Boost_SYSTEM_LIBRARIES}
  )

add_test(
  NAME gcs_tests
  COMMAND gcs_tests
  )

=== debian/changelog ===
galera-4 (26.4.14) UNRELEASED; urgency=medium

  * Galera 4 release

 -- Codership Oy <info@codership.com>  Thu, 26 Jan 2023 09:31:00 +0200

=== debian/control ===
Source: galera-4
Maintainer: Codership Oy <info@codership.com>
Uploaders: Otto Kekäläinen <otto@kekalainen.net>
Section: database
Priority: optional
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends: check,
               cmake (>= 2.8),
               debhelper (>= 10),
               libasio-dev,
               libboost-dev (>= 1.41),
               libboost-filesystem-dev (>= 1.41),
               libboost-program-options-dev (>= 1.41),
               libssl-dev
Homepage: https://www.galeracluster.com/
Vcs-Git: https://github.com/codership/galera.git
Vcs-Browser: https://github.com/codership/galera

Package: galera-4
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: galera-3,
           garbd-2,
           garbd-3,
           garbd2,
           garbd3,
           percona-galera-3,
           percona-galera-4,
           percona-xtradb-cluster-galera,
           percona-xtradb-cluster-galera-2.x,
           percona-xtradb-cluster-galera-3.x,
           percona-xtradb-cluster-galera-4.x,
           percona-xtradb-cluster-garbd-2.x,
           percona-xtradb-cluster-garbd-3.x
Breaks: galera
Replaces: galera
Provides: galera,
          galera4,
          percona-xtradb-cluster-galera-26,
          wsrep
Description: Replication framework for transactional applications
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see https://github.com/codership/wsrep-API. For a description
 of Galera replication engine see http://galeracluster.com.
 .
 This package contains the Galera library/plugin.

Package: galera-4-dbg
Architecture: any
Section: debug
Priority: extra
Depends: galera-4 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for galera-4
 This package contains the debugging symbols for galera-4.

Package: galera-arbitrator-4
Architecture: any
Conflicts: galera-arbitrator-3,
           garbd-2,
           garbd2,
           percona-galera-arbitrator-3,
           percona-galera-arbitrator-4,
           percona-xtradb-cluster-garbd-2.x
Breaks: percona-xtradb-cluster-galera-2.x
Replaces: percona-xtradb-cluster-galera-2.x
Depends: lsb-base (>= 3.0-6),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Galera arbitrator daemon
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see https://github.com/codership/wsrep-API. For a description
 of Galera replication engine see http://galeracluster.com.
 .
 This package contains the Galera arbitrator daemon (garbd).

Package: galera-arbitrator-4-dbg
Architecture: any
Section: debug
Priority: extra
Conflicts: percona-xtradb-cluster-galera-2.x-dbg
Depends: galera-arbitrator-4 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for galera-arbitrator-4
 This package contains the debugging symbols for galera-arbitrator-4.

=== debian/rules ===
#!/usr/bin/make -f

# Enable Debian Hardening
# https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
# Include all defaults, includes buildflags.mk
include /usr/share/dpkg/default.mk
# The following is not available on Debian6
# Galera Version
ifneq (,$(filter version=%,$(DEB_BUILD_OPTIONS)))
       VERSION = $(filter version=%,$(DEB_BUILD_OPTIONS))
       SCONS_ARGS += $(VERSION)
endif

# Galera revision number
ifneq (,$(filter revno=%,$(DEB_BUILD_OPTIONS)))
       REVNO = $(filter revno=%,$(DEB_BUILD_OPTIONS))
       SCONS_ARGS += $(REVNO)
endif


# Set unit test timeout multiplier to make slow tests
# pass on loaded builders.
export CK_TIMEOUT_MULTIPLIER=5

override_dh_auto_test:
	dh_auto_test -O--no-parallel -- ARGS=--output-on-failure

# Start earlier than MySQL which has value 19
override_dh_installinit-arch:
	dh_installinit -n --name=garb -- defaults 18 22

override_dh_strip:
	dh_strip -pgalera-4 --dbg-package=galera-4-dbg
	dh_strip -pgalera-arbitrator-4 --dbg-package=galera-arbitrator-4-dbg

override_dh_installsystemd:
	dh_installsystemd --name=garb

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:

	dh $@ --list-missing

.PHONY: override_dh_strip
